

#include <iostream>

#include <solution.h>
#include <sphereEval.h>
#include <random>

#include "onePlusOneES.h"
#include "fifthES.h"

std::mt19937 generator;

void init(Solution & _solution) {
  std::uniform_real_distribution<double> rng(-10, 10);
  
  _solution.x1 = rng(generator); // random in [-10:10]
  _solution.x2 = rng(generator); // random in [-10:10]
}


int main() {
  generator.seed(time(0));
  
  SphereEval eval;

  Solution s;
  
  FifthES es(10000, 0.1, eval, generator);
//  OnePlusOneES es(10000, 0.1, eval, generator);
  
  /* Algo */
  
  init(s);
  eval.apply(s);
  
  /*
  std::cout << "initial: ";
  s.printOn();
  std::cout << std::endl;
*/
  
  es.run(s);
  /*
  std::cout << "final  : ";
  s.printOn();
  std::cout << std::endl;
   */
   }