#ifndef __OnePlusOneES__H
#define __OnePlusOneES__H

#include <es.h>
#include <solution.h>

class OnePlusOneES : public ES {
public:
  OnePlusOneES(int _maxEval,
               double _sigma,
               Eval & _evalf,
               std::mt19937 & _generator) : maxEval(_maxEval), sigma(_sigma), evalf(_evalf), generator(_generator) {
    
  }
  
  virtual void run(Solution & _solution) {
    std::normal_distribution<double> distribution(0.0, 1.0);
    int nbEval = 0;
    
    Solution s2;
    
    while (nbEval < maxEval) {
      _solution.printOn();
      std::cout << std::endl;
      
      s2.x1 = _solution.x1 + sigma * distribution(generator);
      s2.x2 = _solution.x2 + sigma * distribution(generator);
      
      evalf.apply(s2);
      
      if (s2.fitness() < _solution.fitness()) {
        _solution.x1 = s2.x1;
        _solution.x2 = s2.x2;
        _solution.fitness(s2.fitness());
      }
      
      nbEval++;
    }
  }

protected:
  int maxEval;
  std::mt19937 & generator;
  double sigma;
  Eval & evalf;
  
};
#endif